%{
	#include <stdio.h>
	#include <stdlib.h>
	#include <math.h>
	typedef struct x
	{
		double licznik;
		double mianownik;
	} Liczba;
	Liczba* liczby;
	int indeks = 0;

	// Najwyzszy Wspolny Dzielnik obliczony euklidesem
	int NWD(int a, int b)
	{
		int pomocnicza;

		while(b!=0)
		{
			pomocnicza = b;
			b = a%b;
			a = pomocnicza;
		}

		return a;
	}

	int utworz(double licznik, double mianownik)
	{
		// zaalokowanie pamieci na liczbe
		Liczba* liczba = (Liczba*) malloc(sizeof(Liczba));
		// wyliczenie Najwyzszego Wspolnego Dzielnika 'euklidesem' dla licznika i mianownika
		int nwd = NWD(licznik, mianownik);
		// licznik podzielic przez NWD
		liczba->licznik = licznik / nwd;
		// mianownik podzielic przez NWD
		liczba->mianownik = mianownik / nwd;
		// zapis nowo powstalej liczby do tabeli
		liczby[indeks++] = *liczba;
		// zwrocenie indeksu z tabeli pod ktorym zapisano liczbe
		return indeks-1;
	}

	int dodaj(int indeksLiczby1, int indeksLiczby2)
	{
		Liczba liczba1 = liczby[indeksLiczby1];
		Liczba liczba2 = liczby[indeksLiczby2];
		// do wspolnej podstawy i dodawanie
		return utworz(liczba1.licznik * liczba2.mianownik + liczba2.licznik * liczba1.mianownik, liczba1.mianownik * liczba2.mianownik);
	}

	int odejmij(int indeksLiczby1, int indeksLiczby2)
	{
		Liczba liczba1 = liczby[indeksLiczby1];
		Liczba liczba2 = liczby[indeksLiczby2];
		// do wspolnej podstawy i odejmowanie
		return utworz(liczba1.licznik * liczba2.mianownik - liczba2.licznik * liczba1.mianownik, liczba1.mianownik * liczba2.mianownik);
	}

	int pomnoz(int indeksLiczby1, int indeksLiczby2)
	{
		Liczba liczba1 = liczby[indeksLiczby1];
		Liczba liczba2 = liczby[indeksLiczby2];
		// licznik razy licznik, mianownik razy mianownik
		return utworz(liczba1.licznik * liczba2.licznik, liczba1.mianownik * liczba2.mianownik);
	}

	int podziel(int indeksLiczby1, int indeksLiczby2)
	{
		Liczba liczba1 = liczby[indeksLiczby1];
		Liczba liczba2 = liczby[indeksLiczby2];
		// dzielenie = mnozenie przez odwrotnosc
		return utworz(liczba1.licznik * liczba2.mianownik, liczba1.mianownik * liczba2.licznik);
	}

	int poteguj(int indeksLiczby1, int indeksLiczby2)
	{
		Liczba liczba1 = liczby[indeksLiczby1];
		Liczba liczba2 = liczby[indeksLiczby2];
		int wykladnik = liczba2.licznik / liczba2.mianownik;
		// dzielenie = mnozenie przez odwrotnosc
		return utworz(pow(liczba1.licznik, wykladnik), pow(liczba1.mianownik, wykladnik));
	}

	int pierwiastkuj(int indeksLiczby1, int indeksLiczby2)
	{
		// liczba1 = podstawa, liczba2 = stopien pierwiastka
		Liczba liczba1 = liczby[indeksLiczby1];
		Liczba liczba2 = liczby[indeksLiczby2];
		// przed obliczeniem musimy zamienic ulamki zwykle na dziesietne, bo tylko takie 'rozumie' C++
		double a = liczba1.licznik / liczba1.mianownik;
		double n = liczba2.licznik / liczba2.mianownik;

		// wynikiem bedzie jakis ulamek o podstawie 1 np. 1.41|1
		return utworz(exp(log(a)/n), 1);
	}
%}

%token LICZBA PLUS MINUS KRESKA_ULAMEK MNOZ DZIEL POTEGA PIERWIASTEK NAWIAS_START NAWIAS_KONIEC

%%
wejscie: wyrazenie { printf("\nWynik: %g|%g\n", liczby[$1].licznik, liczby[$1].mianownik); }
;

wyrazenie: wyrazenie PLUS podWyrazenie { $$ = dodaj($1, $3); }
| wyrazenie MINUS podWyrazenie { $$ = odejmij($1, $3); }
| podWyrazenie
;

podWyrazenie: podWyrazenie MNOZ podPodWyrazenie { $$ = pomnoz($1, $3); }
| podWyrazenie DZIEL podPodWyrazenie { $$ = podziel($1, $3); }
| podPodWyrazenie
;

podPodWyrazenie: podPodWyrazenie POTEGA liczba { $$ = poteguj($1, $3); }
| podPodWyrazenie PIERWIASTEK liczba { $$ = pierwiastkuj($1, $3); }
| liczba
;

liczba: LICZBA wczytanieUlamka { $$ = utworz($1, $2); } 
| NAWIAS_START wyrazenie NAWIAS_KONIEC { $$ = $2 } 
;

wczytanieUlamka: KRESKA_ULAMEK LICZBA { $$ = $2; }
| { $$ = 1; } /* jesli nie ma kreski ulamkowej to mianownik = 1 */
;

%%

int yyerror(char *s)
{
	printf("wzor zawiera nie dozwolone znaki lub kolejnosc znakow: %s\n",s);
}

int main(void)
{
	liczby = (Liczba*) malloc(1000 * sizeof(Liczba*));
	yyparse();
}
