%{
	#include <stdio.h>
	#include <strings.h>
enum Attr
{
	PUBLIC,
	PRIVATE,
	PROTECTED,
	STATIC,
	FINAL,
	ABSTRACT,
	NATIVE,
	SYNCHRONIZED,
	TRANSIENT,
	VOLATILE,
	HAS_BODY
};
%}
%union
{
	char	*sval;
	int	dval;
};
%token <sval> IDENTIFIER
%token <dval> ATTRIBUTE
%token PACKAGE
%token IMPORT
%token DOT
%token STAR
%token DECNUMBER
%token SEMICOLON

%token CLASS_HEADER
%token IMPLEMENTS
%token EXTENDS
%token BLOCK_START
%token BLOCK_END
%token METHOD_ARGUMENTS_START
%token METHOD_ARGUMENTS_END
%token GENERIC_START
%token GENERIC_END
%token EQUALS
%token COMMA
%token SOMETHING


%%
/* STEP 1 */
input1		: package1 input2
    		;
/* STEP 2 */
input2		: import0 input3
		;
/* STEP 3 */
input3		: attributes input4
		;
/* STEP 4 */
input4		: CLASS_HEADER {printf("class\n");} objectType {printf("[wczytano nazwe klasy]\n");} input5
		;
/* STEP 5 */
input5		: EXTENDS {printf("extends\n");} objectType {printf("[wczytano  extends]\n");} input6
		| input6
		;
/* STEP 6 */
input6		: IMPLEMENTS {printf("implements\n");} implements0 {printf("[wczytano  implements]\n");} input7
		| input7
		;
/* STEP 7 */
input7		: BLOCK_START classBodyCnt0 BLOCK_END input8
		;
/* STEP 8 */
input8		: input3
		| {printf("[koniec wczytywania klasy]\n");}
		;



/* wczytanie klasy w klasie, samo z siebie nie wczytuje kilku z rzedu, bo classBodyCnt0 i tak zawiera zapetlenie */
iinput4		: CLASS_HEADER {printf("class\n");} objectType {printf("[wczytano nazwe klasy]\n");} iinput5
		;
iinput5		: EXTENDS {printf("extends\n");} objectType {printf("[wczytano  extends]\n");} iinput6
		| iinput6
		;

iinput6		: IMPLEMENTS {printf("implements\n");} implements0 {printf("[wczytano  implements]\n");} iinput7
		| iinput7
		;

iinput7		: BLOCK_START classBodyCnt0 BLOCK_END
		;
 

classBodyCnt0	: classBodyCnt0 attributes classBodyCnt1
		|
		;
classBodyCnt1	: objectType {printf("[wczytano typ]\n");} objectType {printf("[wczytano nazwe]\n");} classBodyCnt2
		| iinput4
		;
classBodyCnt2	: METHOD_ARGUMENTS_START {printf("[poczatek argumentow funkcji]\n");} argument0 METHOD_ARGUMENTS_END {printf("[koniec argumentow funkcji]\n");} methodBody0
		| EQUALS {printf("=\n");} varValue0 SEMICOLON {printf("; [zmienna z wartoscia]\n");}
		| SEMICOLON {printf("; [zmienna bez wartosci]\n");}
		;

argument0	: objectType {printf("[arg typ]\n");} objectType {printf("[arg var]\n");} argument1
		|
		;
argument1	: COMMA {printf("arg: ,[koejny argument]\n");} argument2;
		|
		;
argument2	: objectType {printf("[arg typ]\n");} objectType {printf("[arg var]\n");} argument1
		;



varValue0	: varValue2 varValue1
		;
varValue1	: varValue1 varValue2
		|
		;
varValue2	: IDENTIFIER {}
		| ATTRIBUTE {}
		| PACKAGE
		| IMPORT
		| DOT
		| STAR
		| DECNUMBER
		| BLOCK_START
		| BLOCK_END
		| CLASS_HEADER
		| IMPLEMENTS
		| EXTENDS
		| METHOD_ARGUMENTS_START
		| METHOD_ARGUMENTS_END
		| GENERIC_START
		| GENERIC_END
		| EQUALS
		| COMMA
		| SOMETHING
		;


methodBody0	: SEMICOLON {printf("; [funkcja bez body]\n");}
		| BLOCK_START methodBody1 BLOCK_END {printf("[funkcja z body]\n");}
		;
methodBody1	: BLOCK_START methodBody1 BLOCK_END
		| methodBody1 IDENTIFIER
		| methodBody1 ATTRIBUTE
		| methodBody1 PACKAGE
		| methodBody1 IMPORT
		| methodBody1 DOT
		| methodBody1 STAR
		| methodBody1 DECNUMBER
		| methodBody1 SEMICOLON
		| methodBody1 CLASS_HEADER
		| methodBody1 IMPLEMENTS
		| methodBody1 EXTENDS
		| methodBody1 METHOD_ARGUMENTS_START
		| methodBody1 METHOD_ARGUMENTS_END
		| methodBody1 GENERIC_START
		| methodBody1 GENERIC_END
		| methodBody1 EQUALS
		| methodBody1 COMMA
		| methodBody1 SOMETHING
		|
		;
/*
		| methodBody1 IDENTIFIER
*/
implements0	: objectType {printf("[wczytano nazwe impl]\n");} implements1
		;
implements1	: COMMA objectType {printf("[wczytano nazwe impl]\n");} implements1
		|
		;

/**/
objectType	: IDENTIFIER {printf("ot: %s\n", $1);} objectType1
		;
objectType1	: DOT {printf("ot: .\n");} objectType2;
		| GENERIC_START {printf("ot: <");} objectType objectAComType0 GENERIC_END {printf("ot: >\n");}
		|
		;
objectType2	: IDENTIFIER {printf("ot:%s\n", $1);} objectType1
		;


/* another object name after comma in generics object type */
objectAComType0	: COMMA objectAComType1 objectAComType0
		| 
		;
objectAComType1	: IDENTIFIER {printf("ot20: %s\n", $1);} objectAComType2
		;
objectAComType2	: DOT {printf("ot2: .\n");} objectAComType3;
		| GENERIC_START {printf("ot2: <\n");} objectType objectAComType0 GENERIC_END {printf("ot2: >\n");}
		|
		;
objectAComType3	: IDENTIFIER {printf("ot22:%s\n", $1);} objectAComType2
		;

/**/

/**/

package1	: PACKAGE {printf("package\n");} package2
		|
		;
package2	: IDENTIFIER {printf("%s\n", $1);} package3
		;
package3	: DOT {printf(".\n");} package4
		| SEMICOLON {printf(";\n");} package5
		;
package4	: IDENTIFIER {printf("%s\n", $1);} package3
		;
package5	: {printf("\n[wczytano package]\n");};



import0		: import0 import1
		|
		;
import1		: IMPORT {printf("import\n");} import2
		;
import2		: IDENTIFIER {printf("%s\n", $1);} import3
		;
import3		: DOT {printf(".\n");} import4
		| SEMICOLON {printf(";\n");} import6
		;
import4		: IDENTIFIER {printf("%s\n", $1);} import3
		| STAR {printf("*\n");} import5
		;
import5		: SEMICOLON {printf(";\n");} import6
		;
import6		: {printf("\n[wczytano import]\n");};

attributes	: attributes ATTRIBUTE { printf("Attr: %d\n", $2); }
		|
		;

%%
int yyerror(char *s)
{
	printf("skladnia wczytywanego kodu jest nie poprawna! [error: %s]\n",s);
}
int main(void)
{
	yyparse();
}
