%{
	#include "parser.h"
	char string[10000];
	int stringPointer = 0;
%}
tagFormat [a-zA-Z0-9:\-]+

%x S_STRING

%%

<INITIAL>{tagFormat} {
	yylval.sval = malloc(strlen((char*)yytext));
	strncpy(yylval.sval, yytext, strlen((char*)yytext));
	return(TAG);
}

<INITIAL>[<]	return(TAGSTART);
<INITIAL>[>]	return(TAGEND);
<INITIAL>[/]	return(SLASH);
<INITIAL>[=]	return(EQUALS);

<INITIAL>\" {
	BEGIN(S_STRING);
	stringPointer = 0;
}

<S_STRING>\\\" {
string[stringPointer++] = '"';
}

<S_STRING>\" {
	BEGIN(INITIAL);
	yylval.sval = malloc(stringPointer+1);
	strncpy(yylval.sval, string, stringPointer);
	yylval.sval[stringPointer] = 0;
	return STRING;
}
<S_STRING>.|\n {
	string[stringPointer++] = yytext[0];
}


<INITIAL>[ \t\n] {
	yylval.sval = malloc(strlen((char*)yytext));
	strncpy(yylval.sval, yytext, strlen((char*)yytext));
	return(WHITESPACE);
}
<INITIAL>. {
	yylval.sval = malloc(strlen((char*)yytext));
	strncpy(yylval.sval, yytext, strlen((char*)yytext));
	return(CONTENT);
}

